//****************************** 615sample.c ********************************
//* This is a sample application program that shows you how to use the
//* API function calls of the loadable Linux device driver '615driver'
//* (for Sensoray Model 615) to develop image-grabbing application(s).
//*
//* Copyright (c) 2002-2003.  Sensoray Co., Inc
//* Author:                   David Stroupe and Charlie X. Liu
//*
//* Revision:
//*	    2002   0.0   David Stroupe   initial
//*    June 2003   0.1   Charlie X. Liu  fixes for caption and sequence
//*    June 2003   0.1.1 Charlie X. Liu  added function for saving image(s)
//*                                      into bitmap file(s)
//*
//* Copyright (C) 2002-2003	 Sensoray Co., Inc.
//*--------------------------------------------------------------------------
//* This program is free software; you can redistribute it and/or
//* modify it under the terms of the GNU General Public License
//* as published by the Free Software Foundation; either version 2
//* of the License, or (at your option) any later version.
//*
//* This program is distributed in the hope that it will be useful,
//* but WITHOUT ANY WARRANTY; without even the implied warranty of
//* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//* GNU General Public License for more details.
//*
//* You should have received a copy of the GNU General Public License
//* along with this program; if not, write to the Free Software
//* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
//* *************************************************************************/


#include <sys/timeb.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <string.h>
#include <sys/mman.h>
#include "615.h"

extern int SvHeaderBMP (int fh, int width, int height, BOOL color);

int main()
{
  int h_File1, h_File2;
  int i, num;
  int width, height;
  char str[200];
  imgstatus status;
  userstatus ustatus;
  BUFFER *pb0, *pb1, *pb2, *pb3;

  int bank1 = open("/dev/CameraBank1", O_RDWR );
  if(bank1 == -1)
  {
    perror("bank1");
    return errno;
  }
  pb0 = (BUFFER*)mmap(0, sizeof(BUFFER), PROT_READ | PROT_WRITE, MAP_SHARED ,bank1 , 0);
  pb1 = (BUFFER*)mmap(0, sizeof(BUFFER), PROT_READ | PROT_WRITE, MAP_SHARED ,bank1 , 0);
  pb2 = (BUFFER*)mmap(0, sizeof(BUFFER), PROT_READ | PROT_WRITE, MAP_SHARED ,bank1 , 0);
  pb3 = (BUFFER*)mmap(0, sizeof(BUFFER), PROT_READ | PROT_WRITE, MAP_SHARED ,bank1 , 0);

  ustatus.jpegon = JPEG_ON;
  ustatus.captionmode = CAP_ON | CAP_MGT;
  ustatus.interlacemode = INT_INT;	//interlaced mode
  memset(ustatus.SEQUENCE, 0, sizeof(ustatus.SEQUENCE));

#if 0     //incorrect seguence sample
          // SEQUENCE[Input_port_#-1][0] = chan # (0-3)
          // SEQUENCE[Input_port_#-1][1] = Assigned camera # (1-16)
  ustatus.SEQUENCE[0][0] = 0;       //  chan   camera   in-port_#
  ustatus.SEQUENCE[0][1] = 5;       //   0  -->  5          1
  ustatus.SEQUENCE[1][0] = 1;
  ustatus.SEQUENCE[1][1] = 6;       //   1  -->  6          2
  ustatus.SEQUENCE[2][0] = 2;
  ustatus.SEQUENCE[2][1] = 7;       //   2  -->  7          3
  ustatus.SEQUENCE[3][0] = 3;
  ustatus.SEQUENCE[3][1] = 8;       //   3  -->  8          4
  ustatus.SEQUENCE[4][0] = 1;       // can not be 4, out of (1-3) are involid
  ustatus.SEQUENCE[4][1] = 9;       //   1  -->  9          5      from here, chan 1 can not be re-sync well, need at least another 3 to switch back to the same chan
  ustatus.SEQUENCE[5][0] = 2;
  ustatus.SEQUENCE[5][1] = 10;      //   2  -->  10         6      chan 2 can not be re-sync well either
  ustatus.SEQUENCE[6][0] = 3;
  ustatus.SEQUENCE[6][1] = 11;      //   3  -->  11         7      messed up for after
  ustatus.SEQUENCE[7][0] = 0;
  ustatus.SEQUENCE[7][1] = 12;      //   0  -->  12         8
  ustatus.SEQUENCE[8][0] = 1;
  ustatus.SEQUENCE[8][1] = 13;      //   1  -->  13         9
  ustatus.SEQUENCE[9][0] = 2;
  ustatus.SEQUENCE[9][1] = 14;      //   2  -->  14        10
  ustatus.SEQUENCE[10][0] = 3;
  ustatus.SEQUENCE[10][1] = 15;     //   3  -->  15        11
  ustatus.SEQUENCE[11][0] = 0;
  ustatus.SEQUENCE[11][1] = 16;     //   0  -->  16        12
  ustatus.SEQUENCE[12][0] = 1;
  ustatus.SEQUENCE[12][1] = 1;      //   1  -->  1         13
  ustatus.SEQUENCE[13][0] = 2;
  ustatus.SEQUENCE[13][1] = 2;      //   2  -->  2         14
  ustatus.SEQUENCE[14][0] = 3;
  ustatus.SEQUENCE[14][1] = 3;      //   3  -->  3         15
  ustatus.SEQUENCE[15][0] = 0;
  ustatus.SEQUENCE[15][1] = 4;      //   0  -->  4         16
  ustatus.SEQUENCE[16][0] = 2;
  ustatus.SEQUENCE[16][1] = 0;      //   2  -->  terminator
#endif
#if 0     // suggested correct sequence sample 1:   for 4 inputs	been tested
  ustatus.SEQUENCE[0][0] = 0;       //  chan   camera   in-port_#
  ustatus.SEQUENCE[0][1] = 1;       //   0  -->  1          1
  ustatus.SEQUENCE[1][0] = 1;
  ustatus.SEQUENCE[1][1] = 2;       //   1  -->  2          2
  ustatus.SEQUENCE[2][0] = 2;
  ustatus.SEQUENCE[2][1] = 3;       //   2  -->  3          3
  ustatus.SEQUENCE[3][0] = 3;
  ustatus.SEQUENCE[3][1] = 4;       //   3  -->  4          4
  ustatus.SEQUENCE[4][0] = 0;
  ustatus.SEQUENCE[4][1] = 0;       //   0  -->  0      terminator
#endif
#if 0     // suggested correct sequence sample 2:   for 8 inputs	been tested
  ustatus.SEQUENCE[0][0] = 0;       //  chan   camera   in-port_#
  ustatus.SEQUENCE[0][1] = 5;       //   0  -->  5          1
  ustatus.SEQUENCE[1][0] = 1;
  ustatus.SEQUENCE[1][1] = 6;       //   1  -->  6          2
  ustatus.SEQUENCE[2][0] = 2;
  ustatus.SEQUENCE[2][1] = 7;       //   2  -->  7          3
  ustatus.SEQUENCE[3][0] = 3;
  ustatus.SEQUENCE[3][1] = 8;       //   3  -->  8          4
  ustatus.SEQUENCE[4][0] = 0;
  ustatus.SEQUENCE[4][1] = 1;       //   0  -->  1          5
  ustatus.SEQUENCE[5][0] = 1;
  ustatus.SEQUENCE[5][1] = 2;       //   1  -->  2          6
  ustatus.SEQUENCE[6][0] = 2;
  ustatus.SEQUENCE[6][1] = 3;       //   2  -->  3          7
  ustatus.SEQUENCE[7][0] = 3;
  ustatus.SEQUENCE[7][1] = 4;       //   3  -->  4          8
  ustatus.SEQUENCE[8][0] = 0;
  ustatus.SEQUENCE[8][1] = 0;       //   0  -->  0       terminator
#endif
#if 0     // suggested correct sequence sample 3:   for 16 inputs	been tested
  ustatus.SEQUENCE[0][0] = 0;       //  chan   camera   in-port_#
  ustatus.SEQUENCE[0][1] = 5;       //   0  -->  5          1
  ustatus.SEQUENCE[1][0] = 1;
  ustatus.SEQUENCE[1][1] = 6;       //   1  -->  6          2
  ustatus.SEQUENCE[2][0] = 2;
  ustatus.SEQUENCE[2][1] = 7;       //   2  -->  7          3
  ustatus.SEQUENCE[3][0] = 3;
  ustatus.SEQUENCE[3][1] = 8;       //   3  -->  8          4
  ustatus.SEQUENCE[4][0] = 0;
  ustatus.SEQUENCE[4][1] = 9;       //   0  -->  9          5
  ustatus.SEQUENCE[5][0] = 1;
  ustatus.SEQUENCE[5][1] = 10;      //   1  -->  10         6
  ustatus.SEQUENCE[6][0] = 2;
  ustatus.SEQUENCE[6][1] = 11;      //   2  -->  11         7
  ustatus.SEQUENCE[7][0] = 3;
  ustatus.SEQUENCE[7][1] = 12;      //   3  -->  12         8
  ustatus.SEQUENCE[8][0] = 0;
  ustatus.SEQUENCE[8][1] = 13;      //   0  -->  13         9
  ustatus.SEQUENCE[9][0] = 1;
  ustatus.SEQUENCE[9][1] = 14;      //   1  -->  14        10
  ustatus.SEQUENCE[10][0] = 2;
  ustatus.SEQUENCE[10][1] = 15;     //   2  -->  15        11
  ustatus.SEQUENCE[11][0] = 3;
  ustatus.SEQUENCE[11][1] = 16;     //   3  -->  16        12
  ustatus.SEQUENCE[12][0] = 0;
  ustatus.SEQUENCE[12][1] = 1;      //   0  -->  1         13
  ustatus.SEQUENCE[13][0] = 1;
  ustatus.SEQUENCE[13][1] = 2;      //   1  -->  2         14
  ustatus.SEQUENCE[14][0] = 2;
  ustatus.SEQUENCE[14][1] = 3;      //   2  -->  3         15
  ustatus.SEQUENCE[15][0] = 3;
  ustatus.SEQUENCE[15][1] = 4;      //   3  -->  4         16
  ustatus.SEQUENCE[16][0] = 0;
  ustatus.SEQUENCE[16][1] = 0;      //   0  -->  0       terminator
#endif
#if 0     // suggested correct sequence sample 4:   for 3 inputs	been tested
  ustatus.SEQUENCE[0][0] = 0;       //  chan   camera   in-port_#
  ustatus.SEQUENCE[0][1] = 1;       //   0  -->  1          1
  ustatus.SEQUENCE[1][0] = 1;
  ustatus.SEQUENCE[1][1] = 2;       //   1  -->  2          2
  ustatus.SEQUENCE[2][0] = 2;
  ustatus.SEQUENCE[2][1] = 3;       //   2  -->  3          3
  ustatus.SEQUENCE[3][0] = 0;
  ustatus.SEQUENCE[3][1] = 0;       //   0  -->  0      terminator
#endif
  // suggested correct sequence sample 5:   for 2 inputs/cameras	been tested
  ustatus.SEQUENCE[0][0] = 0;       //  chan   camera   in-port_#
  ustatus.SEQUENCE[0][1] = 1;       //   0  -->  1          1
  ustatus.SEQUENCE[1][0] = 1;
  ustatus.SEQUENCE[1][1] = 2;       //   1  -->  2          2
  ustatus.SEQUENCE[2][0] = 0;
  ustatus.SEQUENCE[2][1] = 0;       //   0  -->  0      terminator
#if 0     // suggested correct sequence sample 6:   for 1 input/camera		been tested
  ustatus.SEQUENCE[0][0] = 0;       //  chan   camera   in-port_#
  ustatus.SEQUENCE[0][1] = 1;       //   0  -->  1          1
  ustatus.SEQUENCE[1][0] = 0;
  ustatus.SEQUENCE[1][1] = 0;       //   0  -->  0      terminator
#endif


  ustatus.mode.format = FORMAT_NTSC;
  ustatus.mode.bmpflip = FLIP_ON;
  ustatus.mode.bmpcolor = COLOR_RGB;     //   COLOR_RGB
  ustatus.mode.bmpsize = BMP_SIZE_LRG;   // ~ 256 x 192
  ustatus.mode.jpgsize = JPG_SIZE_FULL;  // ~ 704 x 480
  ustatus.mode.captionformat = CAP16X4;
  ustatus.mode.captionpos = CP_LR;
  ustatus.mode.fontsize = CF_SMALL;
  ustatus.mode.compfactor = 0xff;
  ustatus.mode.xpinit = XPS_INIT;

  write(bank1, &ustatus, sizeof(userstatus));

  ioctl(bank1, S615Start);
  for (i=0; i < 100; i++)
  {
      num = read(bank1, &status, sizeof(imgstatus));
      if(num == sizeof(status))
      {
	  // do stuff with the buffer
	  printf("Reading from buffer #%i i=%i num=%i videopresent = %i camera #%i size= %i\n", status.buffernumber, i, num, status.videopresent, status.camera, status.jpegsize);
	  
	  //printf("\t\t %i.jpg <== camera %i \n", status.camera, status.camera);
	  sprintf(str, "%i.jpg", i); //status.camera);
	  //	  sprintf(str, "/home/dstroupe/pictures/%i.jpg", i);
	  h_File1 = creat (str, S_IRWXU);
	  write (h_File1, status.pjpg, status.jpegsize);
	  close (h_File1);

	  sprintf(str, "%i.bmp", i); //status.camera);
	  //	  sprintf(str, "/home/dstroupe/pictures/%i.bmp", i);
	  h_File2 = creat (str, S_IRWXU);

		/* make BMP header and save it into the file */
		width = BMPPIXELS_NTSC_LRG;	// 256
		height = BMPLINES_NTSC_LRG;	// 192

		if ( SvHeaderBMP(h_File2, width, height, 1)!=0 ) {
			printf("bmp header write-in failed: \n");
			exit(1);
		}

	  write (h_File2, status.pbmp, SYS_BMPSIZE);
	  close (h_File2);
	  memset(status.pjpg, 0, sizeof(BUFFER));
	  ioctl(bank1, S615FreeBuffer, &status.buffernumber);
	  num=0;
      } else {
	  //printf("\twhen i = %i, num of read-out != sizeof(status)\n", i);
	  i--;
      }
  }

  ioctl(bank1, S615Stop);

  munmap(pb0, sizeof(BUFFER));
  munmap(pb1, sizeof(BUFFER));
  munmap(pb2, sizeof(BUFFER));
  munmap(pb3, sizeof(BUFFER));

  close (bank1);

  return 0;

}

